#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);
    int n, q;
    cin >> n >> q;
    long long d[n + 10];
    long long p[n + 10];
    long long k[q + 10];
    for (int i = 1; i <= n; i++)
        cin >> d[i] >> p[i];
    for (int i = 1; i <= q; i++)
        cin >> k[i];
    int dan = 1;
    long long s = 0;
    int m = k[q] + 10;
    int a[m];
    a[0] = 0;
    for (int i = 1; i <= m; i++) {
        a[i] = a[i - 1];
        if (dan <= n && i == d[dan]) {
            s += p[d[dan]];
            dan++;
        }
        if (s > 0) {
            a[i]++;
            s--;
        }
    }
    for (int i = 1; i <= q; i++)
        cout << a[k[i]] << '\n';
    return 0;
}